

//Declare endogenous variables

var y  c  pi n i etta  nu psi thetar z x mc y_flex  c_flex etta_flex pi_flex n_flex i_flex gapch etta_obs N_obs GAP_obs I_obs PI_OYA_obs chi  gapchauxs gapchaux CV  CV_obs;

//Declare exogenous shocks
varexo epsz;
varexo epstheta;
varexo epspsy;
varexo epsnu;
varexo epsygap;
varexo epschi;


//Declare parameters
parameters betar omegar eter sigmer  gammar rhoz rhotheta phipi phix rhopsy rhonu  thetabar
sigz signu sigp sigt deltarp etah lambdaetaeta thetax thetaeta lambdaeta nuu taua taub sigc rhochi;

//Initialize parameters
betar = 0.99;
omegar=0.781;
eter =1.3 ;
sigmer=2.5;
gammar =0.01;
rhotheta =0.89;
phipi =1.7;
phix = 0.1;
rhopsy = 0.7;
rhonu =0.15;
rhoz= 0.95;
rhochi=0.85;
thetabar=6;

lambdaeta= 0.5;
lambdaetaeta =0.5;
thetax = 0.7;
thetaeta =1.38;

sigz=0.0045;
signu=0.0024;
sigt=0.0014;
sigp=0.0045;
sigc=0.005;


deltarp=0.75;
etah=0.8;

nuu=0.005;
taua=0.002;
taub=0.002;

//Equilibrium equations
model;

# kappar=(((1-omegar)*(1-betar*omegar))/(omegar*(1+betar*deltarp)));
# kappartwo=(betar/(1+betar*deltarp));
# kapparthree=(deltarp/(1+betar*deltarp));
# kapparfour=(((rhotheta*omegar*betar-1)*(1-omegar))/((thetabar-1)*omegar*(1+betar*deltarp)));

(c-etah*c(-1))=(c(+1)-etah*c)-(((nuu+taua*etta(-1)+taub*etta(-2))^2)^(1/2))*epsygap-gammar*etta-((1-etah)/sigmer)*(i-pi(+1));

pi=kappar*mc+kappartwo*pi(+1)+kapparthree*pi(-1)+kapparfour*thetar;

mc=eter*c+(sigmer/(1-etah))*(c-etah*c(-1))-(1+eter)*z+chi;

%I have flipped the sign of lambdaeteta
etta= lambdaeta*etta(-1)-lambdaetaeta*etta(-2)-thetaeta*x(+1)-thetax*x+psi;

i=exp(phipi)*pi+exp(phix)*x+nu;

y=c;

n=y-z;

x=y-y_flex;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//here we insert the flex price model

(c_flex-etah*c_flex(-1))=(c_flex(+1)-etah*c_flex)-gammar*etta_flex-(((nuu+taua*etta(-1)+taub*etta(-2))^2)^(1/2))*epsygap-((1-etah)/sigmer)*(i_flex-pi_flex(+1));

z+(1/thetabar)*thetar=eter*n_flex+(sigmer/(1-etah))*(c_flex-etah*c_flex(-1))+chi;

etta_flex= lambdaeta*etta_flex(-1)-lambdaetaeta*etta_flex(-2)+psi;

y_flex=n_flex+z;

y_flex=c_flex;

i_flex=exp(phipi)*pi_flex+nu;

gapch=x-x(-1);

gapchaux=gapch(+1);
gapchauxs=gapch(+1)^2;

CV=gapchauxs-gapchaux^2;

CV_obs=CV(-1);

etta_obs=etta;
N_obs=n;
GAP_obs=x;
I_obs=i;
PI_OYA_obs=(pi+pi(-1)+pi(-2)+pi(-3));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//Shock Processes
z=rhoz*z(-1)+sigz*epsz;
thetar=rhotheta*thetar(-1)+sigt*epstheta;
nu=rhonu*nu(-1)+signu*epsnu;
psi=rhopsy*psi(-1)+sigp*epspsy;
chi=rhochi*chi(-1)+sigc*epschi;

end;

steady;

//Calculate eigenvalues
check;

shocks;

var epsygap =1;
var epstheta =1;
var epsnu =1;
var epsz =1;
var epspsy=1;
var epschi=1;
var N_obs=0.005^2;
var etta_obs=0.005^2; 
var GAP_obs =0.005^2;
var I_obs =0.005^2;
var PI_OYA_obs=0.005^2;
var CV_obs=0.005^2;

end;

stoch_simul( order=2, irf =0,nograph) ;

estimated_params;

%parameter,distribution,Mean, std. error.

%parameter of the IS curve
omegar,beta_pdf,0.75,0.1; 
deltarp,beta_pdf,0.75,0.15;
etah,beta_pdf,0.7,0.1;

%parameter of the taylor rule 
%phipi, normal_pdf,0.5306,0.05;
%phix,normal_pdf,-2.0794,0.5;

%concerning the exogenous processes
 sigz,inv_gamma_pdf,0.005,0.002;
 sigt,inv_gamma_pdf,0.005,0.002;
 signu,inv_gamma_pdf,0.005,0.002;
 sigp,inv_gamma_pdf,0.005,0.002;
 sigc,inv_gamma_pdf,0.005,0.002;

rhonu, beta_pdf, 0.85,0.1;
rhoz, beta_pdf, 0.85,0.1;
rhotheta, beta_pdf, 0.85,0.1;
rhopsy, beta_pdf, 0.85,0.1;
rhochi, beta_pdf, 0.85,0.1;

gammar,beta_pdf,0.09,0.04; 
lambdaeta,inv_gamma_pdf,0.5,0.25;                    
lambdaetaeta,inv_gamma_pdf,0.5,0.25;  
thetax,inv_gamma_pdf,0.7,0.15;                       
thetaeta, inv_gamma_pdf,1.38,0.3; 

nuu,inv_gamma_pdf,0.005,0.002;
taua,normal_pdf,0.002,0.002;
taub,inv_gamma_pdf,0.002,0.002;

stderr N_obs,inv_gamma_pdf,0.005,0.002;
stderr etta_obs ,inv_gamma_pdf,0.005,0.002;
stderr GAP_obs ,inv_gamma_pdf,0.005,0.002;
stderr I_obs ,inv_gamma_pdf,0.005,0.002;
stderr PI_OYA_obs,inv_gamma_pdf,0.005,0.002;
stderr CV_obs,inv_gamma_pdf,0.005,0.002;

end;

estimated_params_init(use_calibration);
end;

varobs N_obs etta_obs GAP_obs I_obs PI_OYA_obs CV_obs;
rng('shuffle')


estimation(order=3, datafile=data,mode_compute=9,graph_format=(fig),mode_check,mh_replic=80000,bayesian_irf,irf=24);

shock_decomposition(parameter_set=posterior_mean);
